## org.eclipse.datatools.connectivity.oda.util.manifest
Class ExtensionManifest

    java.lang.Object
      org.eclipse.datatools.connectivity.oda.util.manifest.ExtensionManifest

    public class ExtensionManifest

extends java.lang.Object

Encapsulates access to the content of an ODA data source plug-in extension manifest.

Field Summary
`static java.lang.String` `CLASS_ATTRIBUTE_NAME`

Method Summary
`DataSetType` `getDataSetType(java.lang.String dataSetElementID)` Returns the DataSetType instance that represents the dataSet element with the given ID defined in this data source extension.
`int` `getDataSetTypeCount()` Returns the number of data set types defined in this ODA data source extension.
`java.lang.String[]` `getDataSetTypeIDs()` Returns an array of ids of the dataSet elements defined in this data source extension.
`DataSetType[]` `getDataSetTypes()` Returns an array of DataSetType instances that represent the dataSet elements defined in this data source extension.
`java.lang.String` `getDataSourceDisplayName()` Returns the display name of the data source element defined in the ODA data source extension.
`org.eclipse.core.runtime.IConfigurationElement` `getDataSourceElement()` Returns the configuration element of this extension's data source element.
`java.lang.String` `getDataSourceElementID()` Returns the ID that uniquely identifies the dataSource element defined in the ODA data source extension.
`java.net.URL` `getDriverLocation()` Returns the driver installation location.
`java.lang.String` `getExtensionID()` Returns the ID that uniquely identifies this ODA data source extension in an ODA consumer application's environment.
`Property[]` `getHiddenProperties()` A convenience method to return an array of Property definition instances that represent the properties defined as hidden by this data source extension.
`java.lang.String` `getNamespace()` Returns the namespace of the plugin that contributes this ODA runtime extension.
`java.lang.String` `getOdaVersion()` Returns the version of the org.eclipse.datatools.connectivity.oda interfaces for which this driver is developed.
`Property[]` `getProperties()` Returns an array of Property definition instances that represent all the properties defined and inherited by this data source extension.
`Property[]` `getProperties(boolean includeInheritedProps)` Returns an array of Property definition instances that represent all the properties defined by this data source extension, plus optionally include inherited ones.
`java.util.Properties` `getPropertiesVisibility()` Returns a Properties collecton of property visibilty settings.
`Property` `getProperty(java.lang.String propertyName)` Returns the Property definition instance that matches the specified name in the list of properties defined by this data source extension.
`java.lang.String` `getRelatedDataSourceId()` Deprecated. As of 3.1.2, replaced by `getRelationships(int)`
`java.util.List<org.eclipse.datatools.connectivity.oda.util.manifest.Relationship>` `getRelationships(int relationshipType)` Returns a list of data source relationships defined with the specified type.
`RuntimeInterface` `getRuntimeInterface()` Returns the runtime interface configuration.
`TraceLogging` `getTraceLogging()` Returns the optional trace logging configuration for the driver.
`Property[]` `getVisibleProperties()` A convenience method to return an array of Property definition instances that represent the properties defined as visible by this data source extension.
`boolean` `isDeprecated()` Indicates whether this extension is defined to be deprecated.
`boolean` `isWrapper()` Indicates whether this extension is defined to be a wrapper.
`boolean` `overrideFiltering()` Indicates whether the visibility of this extension should override that of the filtering by the ODA extension explorer.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### CLASS_ATTRIBUTE_NAME

    public static final java.lang.String CLASS_ATTRIBUTE_NAME

See Also:
  Constant Field Values

Method Detail

### getNamespace

    public java.lang.String getNamespace()

  Returns the namespace of the plugin that contributes this ODA runtime extension.

  Returns:
    the plugin namespace for the ODA driver, null if the driver does not have a namespace.

### getExtensionID

    public java.lang.String getExtensionID()

  Returns the ID that uniquely identifies this ODA data source extension in an ODA consumer application's environment. This is the extension that implements the org.eclipse.datatools.connectivity.oda.dataSource extension point.
  Since each data source extension has one and only one data source element, the element ID is used as the extension ID.

  Returns:
    the data source extension ID.

### getDataSourceElementID

    public java.lang.String getDataSourceElementID()

  Returns the ID that uniquely identifies the dataSource element defined in the ODA data source extension.

  Returns:
    the data source element ID.

### getDataSourceElement

    public org.eclipse.core.runtime.IConfigurationElement getDataSourceElement()

  Returns the configuration element of this extension's data source element.

  Returns:
    a dataSource configuration element

### getDriverLocation

    public java.net.URL getDriverLocation()
                                   throws java.io.IOException

  Returns the driver installation location.

  Returns:
    the driver directory.
  Throws:
    `java.io.IOException` - if an IO error occurs.

### getOdaVersion

    public java.lang.String getOdaVersion()

  Returns the version of the org.eclipse.datatools.connectivity.oda interfaces for which this driver is developed.

  Returns:
    The ODA interface version. Its format is as defined in the extension point schema.

### getDataSourceDisplayName

    public java.lang.String getDataSourceDisplayName()

  Returns the display name of the data source element defined in the ODA data source extension. Defaults to element ID if no display name is specified. It can be used by an ODA consumer application's designer tool to display a list of ODA data source extensions.

  Returns:
    The display name of the ODA data source element.

### getDataSetTypes

    public DataSetType[] getDataSetTypes()

  Returns an array of DataSetType instances that represent the dataSet elements defined in this data source extension.

  Returns:
    an array of data set types; may return an empty array if no dataSet elements are defined.

### getDataSetTypeIDs

    public java.lang.String[] getDataSetTypeIDs()

  Returns an array of ids of the dataSet elements defined in this data source extension.

  Returns:
    an array of data set type IDs; may return an empty array if no dataSet elements are defined.

### getDataSetTypeCount

    public int getDataSetTypeCount()

  Returns the number of data set types defined in this ODA data source extension.

  Returns:
    number of data set types defined; may be zero if none is defined

### getDataSetType

    public DataSetType getDataSetType(java.lang.String dataSetElementID)
                               throws OdaException

  Returns the DataSetType instance that represents the dataSet element with the given ID defined in this data source extension. If the given data set element ID is null and the data source extension supports only one data set type, that data set element will be returned by default.

  Parameters:
    `dataSetElementID` - the id of the data set element.
  Returns:
    the data set element definition.
  Throws:
    `OdaException` - if there is no data set definition associated with the specified data set element ID, or if there are more than one data set elements that match the ID.

### getTraceLogging

    public TraceLogging getTraceLogging()

  Returns the optional trace logging configuration for the driver.

  Returns:
    the trace logging configuration, or null if no trace logging configuration was specified.

### getRuntimeInterface

    public RuntimeInterface getRuntimeInterface()

  Returns the runtime interface configuration.

  Returns:
    the runtime interface configuration.

### getProperties

    public Property[] getProperties()

  Returns an array of Property definition instances that represent all the properties defined and inherited by this data source extension. The collection includes both top-level properties and those in a group, and could be defined as either visible or hidden.

  Returns:
    an array of all property definitions; an empty array is returned if no properties are defined.

### getProperties

    public Property[] getProperties(boolean includeInheritedProps)

  Returns an array of Property definition instances that represent all the properties defined by this data source extension, plus optionally include inherited ones. The collection includes both top-level properties and those in a group, and could be defined as either visible or hidden.

  Parameters:
    `includeInheritedProps` - indicates whether to include property definitions inherited from the ODA framework
  Returns:
    an array of all property definitions; an empty array is returned if no properties are defined.
  Since:
    3.1

### getVisibleProperties

    public Property[] getVisibleProperties()

  A convenience method to return an array of Property definition instances that represent the properties defined as visible by this data source extension. The collection includes both top-level properties and those in a group.

  Returns:
    an array of visible property definitions; an empty array is returned if no visible properties are defined.

### getHiddenProperties

    public Property[] getHiddenProperties()

  A convenience method to return an array of Property definition instances that represent the properties defined as hidden by this data source extension. The collection includes both top-level properties and those in a group.

  Returns:
    an array of hidden property definitions; an empty array is returned if no hidden properties are defined.

### getProperty

    public Property getProperty(java.lang.String propertyName)

  Returns the Property definition instance that matches the specified name in the list of properties defined by this data source extension.

  Parameters:
    `propertyName` - the name of a property
  Returns:
    the matching Property definition, or null if no match is found.

### getPropertiesVisibility

    public java.util.Properties getPropertiesVisibility()

  Returns a Properties collecton of property visibilty settings.

  Returns:
    Properties with the property name as key, and its visibility setting as value. An empty collection if no property visibility is defined.

### isDeprecated

    public boolean isDeprecated()

  Indicates whether this extension is defined to be deprecated.

  Since:
    3.0.3

### isWrapper

    public boolean isWrapper()

  Indicates whether this extension is defined to be a wrapper.

  Since:
    3.1.2

### getRelatedDataSourceId

    public java.lang.String getRelatedDataSourceId()

  Deprecated. As of 3.1.2, replaced by `getRelationships(int)`

  Returns the related oda data source element id, if specified. For backward compatibility, this returns the first related replacedBy id.

  Returns:
    the related oda data source element id, or null if none is specified.
  Since:
    3.0.3

### getRelationships

    public java.util.List<org.eclipse.datatools.connectivity.oda.util.manifest.Relationship> getRelationships(int relationshipType)

  Returns a list of data source relationships defined with the specified type.

  Parameters:
    `relationshipType` - constant for the type of relationship
  Returns:
    a list of specified type of relationships, or null if the specified relationshipType is not defined in this extension.
  Since:
    3.1.2
  See Also:
    `Relationship.TYPE_* constants}`

### overrideFiltering

    public boolean overrideFiltering()

  Indicates whether the visibility of this extension should override that of the filtering by the ODA extension explorer.

  Returns:
  Since:
    3.2.2 (DTP 1.7.2)